Index: XMLIO_V2/dev/dev_rv/src4/xmlio/fortran/ifield.f90
===================================================================
--- XMLIO_V2/dev/dev_rv/src4/xmlio/fortran/ifield.f90	(revision 249)
+++ XMLIO_V2/dev/dev_rv/src4/xmlio/fortran/ifield.f90	(revision 249)
@@ -0,0 +1,232 @@
+MODULE IFIELD
+   USE, INTRINSIC :: ISO_C_BINDING
+   USE FIELD_INTERFACE
+   USE FIELDGROUP_INTERFACE
+   
+   TYPE XFieldHandle
+      INTEGER(kind = C_INTPTR_T) :: daddr
+   END TYPE XFieldHandle
+   
+   TYPE XFieldGroupHandle
+      INTEGER(kind = C_INTPTR_T) :: daddr
+   END TYPE XFieldGroupHandle
+   
+   !----------------------------------------------------------------------------
+   INTERFACE set_field_attributes
+      MODULE PROCEDURE set_field_attributes_id,set_field_attributes_hdl
+   END INTERFACE  
+   
+   INTERFACE set_field_group_attributes
+      MODULE PROCEDURE set_fieldgroup_attributes_id,set_fieldgroup_attributes_hdl
+   END INTERFACE  
+   !----------------------------------------------------------------------------
+   
+   CONTAINS ! Fonctions disponibles pour les utilisateurs.
+    
+   SUBROUTINE set_fieldgroup_attributes_id                                                 &
+   (fieldgroup_id, name_, standard_name_, long_name_, unit_, operation_, freq_op_, level_, &
+    prec_, enabled_, domain_ref_, axis_ref_, grid_ref_, fieldgroup_ref_, default_value_)
+    
+      IMPLICIT NONE
+      TYPE(XFieldGroupHandle)                       :: fieldgroup_hdl
+      CHARACTER(len = *)               , INTENT(IN) :: fieldgroup_id
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: standard_name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: long_name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: unit_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: operation_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: freq_op_
+      INTEGER                , OPTIONAL, INTENT(IN) :: level_
+      INTEGER                , OPTIONAL, INTENT(IN) :: prec_
+      LOGICAL                , OPTIONAL, INTENT(IN) :: enabled_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: domain_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: axis_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: grid_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: fieldgroup_ref_
+      REAL(kind=8)           , OPTIONAL, INTENT(IN) :: default_value_
+        
+      CALL fieldgroup_handle_create(fieldgroup_hdl, fieldgroup_id)
+      CALL set_fieldgroup_attributes_hdl                                                          &
+         (fieldgroup_hdl, name_, standard_name_, long_name_, unit_, operation_, freq_op_, level_, &
+          prec_, enabled_, domain_ref_, axis_ref_, grid_ref_, fieldgroup_ref_, default_value_)
+
+   END SUBROUTINE set_fieldgroup_attributes_id
+
+   SUBROUTINE set_fieldgroup_attributes_hdl                                                 &
+   (fieldgroup_hdl, name_, standard_name_, long_name_, unit_, operation_, freq_op_, level_, &
+    prec_, enabled_, domain_ref_, axis_ref_, grid_ref_, fieldgroup_ref_, default_value_)
+      IMPLICIT NONE
+      TYPE(XFieldgroupHandle)          , INTENT(IN) :: fieldgroup_hdl
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: standard_name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: long_name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: unit_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: operation_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: freq_op_
+      INTEGER                , OPTIONAL, INTENT(IN) :: level_
+      INTEGER                , OPTIONAL, INTENT(IN) :: prec_
+      LOGICAL(kind = 1)                             :: enabled__
+      LOGICAL                , OPTIONAL, INTENT(IN) :: enabled_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: domain_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: axis_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: grid_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: fieldgroup_ref_
+      REAL(kind=8)           , OPTIONAL, INTENT(IN) :: default_value_
+      
+      enabled__ = enabled_  
+      IF (PRESENT(name_))           THEN
+         CALL xios_set_fieldgroup_name(fieldgroup_hdl%daddr, name_, len(name_))
+      END IF
+      IF (PRESENT(standard_name_))  THEN
+         CALL xios_set_fieldgroup_standard_name(fieldgroup_hdl%daddr, standard_name_, len(standard_name_))
+      END IF
+      IF (PRESENT(long_name_))      THEN
+         CALL xios_set_fieldgroup_long_name(fieldgroup_hdl%daddr, long_name_, len(long_name_))
+      END IF
+      IF (PRESENT(unit_))           THEN
+         CALL xios_set_fieldgroup_unit(fieldgroup_hdl%daddr, unit_, len(unit_))
+      END IF
+      IF (PRESENT(operation_))      THEN
+         CALL xios_set_fieldgroup_operation(fieldgroup_hdl%daddr, operation_, len(operation_))
+      END IF
+      IF (PRESENT(freq_op_))        THEN
+         CALL xios_set_fieldgroup_freq_op(fieldgroup_hdl%daddr, freq_op_, len(freq_op_))
+      END IF
+      IF (PRESENT(level_))          THEN
+         CALL xios_set_fieldgroup_level(fieldgroup_hdl%daddr, level_)
+      END IF
+      IF (PRESENT(prec_))           THEN
+         CALL xios_set_fieldgroup_prec(fieldgroup_hdl%daddr, prec_)
+      END IF
+      IF (PRESENT(enabled_))        THEN
+         CALL xios_set_fieldgroup_enabled(fieldgroup_hdl%daddr, enabled__)
+      END IF
+      IF (PRESENT(domain_ref_))     THEN
+         CALL xios_set_fieldgroup_domain_ref(fieldgroup_hdl%daddr, domain_ref_, len(domain_ref_))
+      END IF
+      IF (PRESENT(axis_ref_))       THEN
+         CALL xios_set_fieldgroup_axis_ref(fieldgroup_hdl%daddr, axis_ref_, len(axis_ref_))
+      END IF
+      IF (PRESENT(grid_ref_))       THEN
+         CALL xios_set_fieldgroup_grid_ref(fieldgroup_hdl%daddr, grid_ref_, len(grid_ref_))
+      END IF
+      IF (PRESENT(fieldgroup_ref_))      THEN
+         CALL xios_set_fieldgroup_fieldgroup_ref(fieldgroup_hdl%daddr, fieldgroup_ref_, len(fieldgroup_ref_))
+      END IF
+      IF (PRESENT(default_value_))  THEN
+         CALL xios_set_fieldgroup_default_value(fieldgroup_hdl%daddr, default_value_)
+      END IF
+
+   END SUBROUTINE set_fieldgroup_attributes_hdl
+   
+   SUBROUTINE set_field_attributes_id                                                 &
+   (field_id, name_, standard_name_, long_name_, unit_, operation_, freq_op_, level_, &
+    prec_, enabled_, domain_ref_, axis_ref_, grid_ref_, field_ref_, default_value_)
+    
+      IMPLICIT NONE
+      TYPE(XFieldHandle)                            :: field_hdl
+      CHARACTER(len = *)               , INTENT(IN) :: field_id
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: standard_name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: long_name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: unit_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: operation_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: freq_op_
+      INTEGER                , OPTIONAL, INTENT(IN) :: level_
+      INTEGER                , OPTIONAL, INTENT(IN) :: prec_
+      LOGICAL                , OPTIONAL, INTENT(IN) :: enabled_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: domain_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: axis_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: grid_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: field_ref_
+      REAL(kind=8)           , OPTIONAL, INTENT(IN) :: default_value_
+      
+      CALL field_handle_create(field_hdl, field_id)
+      CALL set_field_attributes_hdl                                                          &
+         (field_hdl, name_, standard_name_, long_name_, unit_, operation_, freq_op_, level_, &
+          prec_, enabled_, domain_ref_, axis_ref_, grid_ref_, field_ref_, default_value_)
+
+   END SUBROUTINE set_field_attributes_id
+
+   SUBROUTINE set_field_attributes_hdl                                                 &
+   (field_hdl, name_, standard_name_, long_name_, unit_, operation_, freq_op_, level_, &
+    prec_, enabled_, domain_ref_, axis_ref_, grid_ref_, field_ref_, default_value_)
+      IMPLICIT NONE
+      TYPE(XFieldHandle)               , INTENT(IN) :: field_hdl
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: standard_name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: long_name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: unit_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: operation_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: freq_op_
+      INTEGER                , OPTIONAL, INTENT(IN) :: level_
+      INTEGER                , OPTIONAL, INTENT(IN) :: prec_
+      LOGICAL(kind = 1)                             :: enabled__
+      LOGICAL                , OPTIONAL, INTENT(IN) :: enabled_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: domain_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: axis_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: grid_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: field_ref_
+      REAL(kind=8)           , OPTIONAL, INTENT(IN) :: default_value_
+      
+      enabled__ = enabled_  
+      IF (PRESENT(name_))           THEN
+         CALL xios_set_field_name(field_hdl%daddr, name_, len(name_))
+      END IF
+      IF (PRESENT(standard_name_))  THEN
+         CALL xios_set_field_standard_name(field_hdl%daddr, standard_name_, len(standard_name_))
+      END IF
+      IF (PRESENT(long_name_))      THEN
+         CALL xios_set_field_long_name(field_hdl%daddr, long_name_, len(long_name_))
+      END IF
+      IF (PRESENT(unit_))           THEN
+         CALL xios_set_field_unit(field_hdl%daddr, unit_, len(unit_))
+      END IF
+      IF (PRESENT(operation_))      THEN
+         CALL xios_set_field_operation(field_hdl%daddr, operation_, len(operation_))
+      END IF
+      IF (PRESENT(freq_op_))        THEN
+         CALL xios_set_field_freq_op(field_hdl%daddr, freq_op_, len(freq_op_))
+      END IF
+      IF (PRESENT(level_))          THEN
+         CALL xios_set_field_level(field_hdl%daddr, level_)
+      END IF
+      IF (PRESENT(prec_))           THEN
+         CALL xios_set_field_prec(field_hdl%daddr, prec_)
+      END IF
+      IF (PRESENT(enabled_))        THEN
+         CALL xios_set_field_enabled(field_hdl%daddr, enabled__)
+      END IF
+      IF (PRESENT(domain_ref_))     THEN
+         CALL xios_set_field_domain_ref(field_hdl%daddr, domain_ref_, len(domain_ref_))
+      END IF
+      IF (PRESENT(axis_ref_))       THEN
+         CALL xios_set_field_axis_ref(field_hdl%daddr, axis_ref_, len(axis_ref_))
+      END IF
+      IF (PRESENT(grid_ref_))       THEN
+         CALL xios_set_field_grid_ref(field_hdl%daddr, grid_ref_, len(grid_ref_))
+      END IF
+      IF (PRESENT(field_ref_))      THEN
+         CALL xios_set_field_field_ref(field_hdl%daddr, field_ref_, len(field_ref_))
+      END IF
+      IF (PRESENT(default_value_))  THEN
+         CALL xios_set_field_default_value(field_hdl%daddr, default_value_)
+      END IF
+
+   END SUBROUTINE set_field_attributes_hdl
+
+   SUBROUTINE field_handle_create(ret, idt)
+      IMPLICIT NONE
+      TYPE(XFieldHandle), INTENT(OUT):: ret
+      CHARACTER(len = *), INTENT(IN) :: idt      
+      CALL xios_field_handle_create(ret%daddr, idt, len(idt))            
+   END SUBROUTINE field_handle_create
+   
+   SUBROUTINE fieldgroup_handle_create(ret, idt)
+      IMPLICIT NONE
+      TYPE(XFieldGroupHandle), INTENT(OUT):: ret
+      CHARACTER(len = *)     , INTENT(IN) :: idt      
+      CALL xios_fieldgroup_handle_create(ret%daddr, idt, len(idt))            
+   END SUBROUTINE fieldgroup_handle_create
+   
+END MODULE IFIELD
Index: XMLIO_V2/dev/dev_rv/src4/xmlio/fortran/ifile.f90
===================================================================
--- XMLIO_V2/dev/dev_rv/src4/xmlio/fortran/ifile.f90	(revision 249)
+++ XMLIO_V2/dev/dev_rv/src4/xmlio/fortran/ifile.f90	(revision 249)
@@ -0,0 +1,127 @@
+MODULE IFILE
+   USE, INTRINSIC :: ISO_C_BINDING
+   USE FILE_INTERFACE
+   USE FILEGROUP_INTERFACE
+   
+   TYPE XFileHandle
+      INTEGER(kind = C_INTPTR_T) :: daddr
+   END TYPE XFileHandle
+   
+   TYPE XFileGroupHandle
+      INTEGER(kind = C_INTPTR_T) :: daddr
+   END TYPE XFileGroupHandle
+   
+   !----------------------------------------------------------------------------
+   INTERFACE set_file_attributes
+      MODULE PROCEDURE set_file_attributes_id,set_file_attributes_hdl
+   END INTERFACE  
+   
+   INTERFACE set_file_group_attributes
+      MODULE PROCEDURE set_filegroup_attributes_id,set_filegroup_attributes_hdl
+   END INTERFACE  
+   !----------------------------------------------------------------------------
+  
+   CONTAINS ! Fonctions disponibles pour les utilisateurs.
+   
+   SUBROUTINE set_file_attributes_id(file_id, name_ , description_, output_freq_, output_level_, enabled_)
+      IMPLICIT NONE
+      TYPE(XFileHandle)                        :: file_hdl
+      CHARACTER(len = *)          , INTENT(IN) :: file_id
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: description_
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: output_freq_
+      INTEGER           , OPTIONAL, INTENT(IN) :: output_level_
+      LOGICAL           , OPTIONAL, INTENT(IN) :: enabled_
+      
+      CALL file_handle_create(file_hdl, file_id)
+      CALL set_file_attributes_hdl(file_hdl, name_ , description_, output_freq_, output_level_, enabled_)
+      
+   END SUBROUTINE set_file_attributes_id
+   
+   SUBROUTINE set_file_attributes_hdl(file_hdl, name_ , description_, output_freq_, output_level_, enabled_)
+      TYPE(XFileHandle)           , INTENT(IN) :: file_hdl
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: description_
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: output_freq_
+      INTEGER           , OPTIONAL, INTENT(IN) :: output_level_
+      LOGICAL(kind = 1)                        :: enabled__
+      LOGICAL           , OPTIONAL, INTENT(IN) :: enabled_
+      
+      enabled__ = enabled_        
+      IF (PRESENT(name_))         THEN
+         CALL xios_set_file_name(file_hdl%daddr, name_, len(name_))
+      END IF
+      IF (PRESENT(description_))  THEN
+         CALL xios_set_file_description(file_hdl%daddr, description_, len(description_))
+      END IF
+      IF (PRESENT(output_freq_))  THEN
+         CALL xios_set_file_output_freq(file_hdl%daddr, output_freq_, len(output_freq_))
+      END IF
+      IF (PRESENT(output_level_)) THEN
+         CALL xios_set_file_output_level(file_hdl%daddr, output_level_)
+      END IF
+      IF (PRESENT(enabled_))      THEN
+         CALL xios_set_file_enabled(file_hdl%daddr, enabled__)
+      END IF
+
+   END SUBROUTINE set_file_attributes_hdl
+   
+   SUBROUTINE set_filegroup_attributes_id(filegroup_id, name_ , description_, output_freq_, output_level_, enabled_)
+      IMPLICIT NONE
+      TYPE(XFileGroupHandle)                   :: filegroup_hdl
+      CHARACTER(len = *)          , INTENT(IN) :: filegroup_id
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: description_
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: output_freq_
+      INTEGER           , OPTIONAL, INTENT(IN) :: output_level_
+      LOGICAL           , OPTIONAL, INTENT(IN) :: enabled_
+      
+      CALL filegroup_handle_create(filegroup_hdl, filegroup_id)
+      CALL set_filegroup_attributes_hdl(filegroup_hdl, name_ , description_, output_freq_, output_level_, enabled_)
+      
+   END SUBROUTINE set_filegroup_attributes_id
+   
+   SUBROUTINE set_filegroup_attributes_hdl(filegroup_hdl, name_ , description_, output_freq_, output_level_, enabled_)
+      IMPLICIT NONE
+      TYPE(XFileGroupHandle)      , INTENT(IN) :: filegroup_hdl
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: description_
+      CHARACTER(len = *), OPTIONAL, INTENT(IN) :: output_freq_
+      INTEGER           , OPTIONAL, INTENT(IN) :: output_level_
+      LOGICAL(kind = 1)                        :: enabled__
+      LOGICAL           , OPTIONAL, INTENT(IN) :: enabled_
+      
+      enabled__ = enabled_         
+      IF (PRESENT(name_))         THEN
+         CALL xios_set_filegroup_name(filegroup_hdl%daddr, name_, len(name_))
+      END IF
+      IF (PRESENT(description_))  THEN
+         CALL xios_set_filegroup_description(filegroup_hdl%daddr, description_, len(description_))
+      END IF
+      IF (PRESENT(output_freq_))  THEN
+         CALL xios_set_filegroup_output_freq(filegroup_hdl%daddr, output_freq_, len(output_freq_))
+      END IF
+      IF (PRESENT(output_level_)) THEN
+         CALL xios_set_filegroup_output_level(filegroup_hdl%daddr, output_level_)
+      END IF
+      IF (PRESENT(enabled_))      THEN
+         CALL xios_set_filegroup_enabled(filegroup_hdl%daddr, enabled__)
+      END IF
+
+   END SUBROUTINE set_filegroup_attributes_hdl
+   
+   SUBROUTINE file_handle_create(ret, idt)
+      IMPLICIT NONE
+      TYPE(XFileHandle) , INTENT(OUT):: ret
+      CHARACTER(len = *), INTENT(IN) :: idt      
+      CALL xios_file_handle_create(ret%daddr, idt, len(idt))            
+   END SUBROUTINE file_handle_create
+   
+   SUBROUTINE filegroup_handle_create(ret, idt)
+      IMPLICIT NONE
+      TYPE(XFileGroupHandle), INTENT(OUT):: ret
+      CHARACTER(len = *)    , INTENT(IN) :: idt      
+      CALL xios_filegroup_handle_create(ret%daddr, idt, len(idt))            
+   END SUBROUTINE filegroup_handle_create
+   
+END MODULE IFILE
Index: XMLIO_V2/dev/dev_rv/src4/xmlio/fortran/igrid.f90
===================================================================
--- XMLIO_V2/dev/dev_rv/src4/xmlio/fortran/igrid.f90	(revision 249)
+++ XMLIO_V2/dev/dev_rv/src4/xmlio/fortran/igrid.f90	(revision 249)
@@ -0,0 +1,112 @@
+MODULE IGRID
+   USE, INTRINSIC :: ISO_C_BINDING
+   USE GRID_INTERFACE
+   USE GRIDGROUP_INTERFACE
+   
+   TYPE XGridHandle
+      INTEGER(kind = C_INTPTR_T) :: daddr
+   END TYPE XGridHandle
+   
+   TYPE XGridGroupHandle
+      INTEGER(kind = C_INTPTR_T) :: daddr
+   END TYPE XGridGroupHandle
+   
+   !----------------------------------------------------------------------------
+   INTERFACE set_grid_attributes
+      MODULE PROCEDURE set_grid_attributes_id,set_grid_attributes_hdl
+   END INTERFACE  
+   
+   INTERFACE set_grid_group_attributes
+      MODULE PROCEDURE set_gridgroup_attributes_id,set_gridgroup_attributes_hdl
+   END INTERFACE  
+   !----------------------------------------------------------------------------
+   
+   CONTAINS ! Fonctions disponibles pour les utilisateurs.
+   
+   SUBROUTINE set_grid_attributes_id(grid_id, name_, description_, domain_ref_, axis_ref_)
+      IMPLICIT NONE
+      TYPE(XGridHandle)                             :: grid_hdl
+      CHARACTER(len = *)               , INTENT(IN) :: grid_id
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: description_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: domain_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: axis_ref_
+      
+      CALL grid_handle_create(grid_hdl, grid_id)
+      CALL set_grid_attributes_hdl(grid_hdl, name_, description_, domain_ref_, axis_ref_)
+
+   END SUBROUTINE set_grid_attributes_id
+
+   SUBROUTINE set_grid_attributes_hdl(grid_hdl, name_, description_, domain_ref_, axis_ref_)
+      IMPLICIT NONE
+      TYPE      (XGridHandle)                       :: grid_hdl
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: description_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: domain_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: axis_ref_
+      
+      IF (PRESENT(name_))        THEN
+       CALL xios_set_grid_name(grid_hdl%daddr, name_, len(name_))
+      END IF
+      IF (PRESENT(description_)) THEN
+       CALL xios_set_grid_description(grid_hdl%daddr, description_, len(description_))
+      END IF
+      IF (PRESENT(domain_ref_))  THEN
+       CALL xios_set_grid_domain_ref(grid_hdl%daddr, domain_ref_, len(domain_ref_))
+      END IF
+      IF (PRESENT(axis_ref_))    THEN
+       CALL xios_set_grid_axis_ref(grid_hdl%daddr, axis_ref_, len(axis_ref_))
+      END IF
+   END SUBROUTINE set_grid_attributes_hdl
+   
+   SUBROUTINE set_gridgroup_attributes_id(gridgroup_id, name_, description_, domain_ref_, axis_ref_)
+      IMPLICIT NONE
+      TYPE(XGridGroupHandle)                        :: gridgroup_hdl
+      CHARACTER(len = *)               , INTENT(IN) :: gridgroup_id
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: description_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: domain_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: axis_ref_
+      
+      CALL gridgroup_handle_create(gridgroup_hdl, gridgroup_id)
+      CALL set_gridgroup_attributes_hdl(gridgroup_hdl, name_, description_, domain_ref_, axis_ref_)
+
+   END SUBROUTINE set_gridgroup_attributes_id
+
+   SUBROUTINE set_gridgroup_attributes_hdl(gridgroup_hdl, name_, description_, domain_ref_, axis_ref_)
+      IMPLICIT NONE
+      TYPE      (XGridGroupHandle)                  :: gridgroup_hdl
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: name_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: description_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: domain_ref_
+      CHARACTER(len = *)     , OPTIONAL, INTENT(IN) :: axis_ref_
+      
+      IF (PRESENT(name_))        THEN
+       CALL xios_set_gridgroup_name(gridgroup_hdl%daddr, name_, len(name_))
+      END IF
+      IF (PRESENT(description_)) THEN
+       CALL xios_set_gridgroup_description(gridgroup_hdl%daddr, description_, len(description_))
+      END IF
+      IF (PRESENT(domain_ref_))  THEN
+       CALL xios_set_gridgroup_domain_ref(gridgroup_hdl%daddr, domain_ref_, len(domain_ref_))
+      END IF
+      IF (PRESENT(axis_ref_))    THEN
+       CALL xios_set_gridgroup_axis_ref(gridgroup_hdl%daddr, axis_ref_, len(axis_ref_))
+      END IF
+   END SUBROUTINE set_gridgroup_attributes_hdl
+
+   SUBROUTINE grid_handle_create(ret, idt)
+      IMPLICIT NONE
+      TYPE(XGridHandle), INTENT(OUT):: ret
+      CHARACTER(len = *), INTENT(IN) :: idt      
+      CALL xios_grid_handle_create(ret%daddr, idt, len(idt))            
+   END SUBROUTINE grid_handle_create
+   
+   SUBROUTINE gridgroup_handle_create(ret, idt)
+      IMPLICIT NONE
+      TYPE(XGridGroupHandle), INTENT(OUT):: ret
+      CHARACTER(len = *)     , INTENT(IN) :: idt      
+      CALL xios_gridgroup_handle_create(ret%daddr, idt, len(idt))            
+   END SUBROUTINE gridgroup_handle_create
+   
+END MODULE IGRID
